/* malloc-bug-test malloc(big)+realloc(low) failes above 4GB */
/*
  gcc492 -Wall -O2 membug201503.c
  (ulimit -v 20000000;MALLOC_CHECK_=2 ./a.out) # MALLOC_CHECK_ does not help!
OOM no 1GB reserve
6714522 * 1kB allocated, but check ps output, more=buggy
  PID USER      PR  NI  VIRT  RES  SHR S %CPU %MEM    TIME+  COMMAND          
  29725 user    39  19 18.8g 6.7g  360 S  0.0  2.7   1:19.48 a.out             
lrwxrwxrwx 1 root root 11 Apr 28  2011 /lib64/libc.so.6 -> libc-2.5.so
...
[pid 28855] mmap(NULL, 21041152, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x2aabfa121000
[pid 28855] mremap(0x2aabfa121000, 21041152, 69632, MREMAP_MAYMOVE) = 0x2aabfa121000
[pid 28855] mmap(NULL, 21041152, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x2aabfa132000
[pid 28855] mremap(0x2aabfa132000, 21041152, 69632, MREMAP_MAYMOVE) = 0x2aabfa132000
[pid 28855] brk(0x1a37d000)             = 0x1a37d000
[pid 28855] brk(0x18f7d000)             = 0x18f7d000
...
[pid 28855] brk(0x3ffc2000)             = 0x3ffc2000
[pid 28855] brk(0x413d2000)             = 0x413d2000
[pid 28855] brk(0x3ffd2000)             = 0x3ffd2000
[pid 28855] brk(0x413e2000)             = 0x3ffd2000
[pid 28855] mmap(NULL, 21172224, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x2aabfa143000
[pid 28855] brk(0x41403000)             = 0x3ffd2000
[pid 28855] mmap(NULL, 21172224, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x2aabfb574000
[pid 28855] brk(0x41403000)             = 0x3ffd2000
  
*/
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
char *a[1000000L*8];  /* 8M*8B = 64MB table */
int main(){
  long long int i; int j;
  for (i=0;i<1000000L*8;i++){
    a[i]=(char *)malloc(1024<<20); /* 1GB */
    if (!a[i]) { printf("OOM no 1GB reserve\n"); break; }
    /* free + malloc(less) would work */
//    free(a[i]);a[i]=(char *)malloc(1<<10); /* reduce to 1kB */
    a[i]=(char *)realloc(a[i], 1<<10); /* reduce to 1kB */
    if (!a[i]) { printf("ralloc faild\n"); break; }
    for (j=0;j<1<<10;j+=4096) a[i][j]=0; /* touch all pages (not needed!) */
  }
  if (i<8) printf("test needs 4GB minimum, bug triggered above\n");
  printf("%Lu * 1kB allocated, but check ps output, much more if buggy\n",i);
  sleep(5*60);
  return 0;
}
