#include <stdlib.h>
#include <stdio.h>

/*
   run:
    ./memtest 3000 $(hostname) verbose
    srun -p scx-comp -N 1 bash -c "./memtest 3000 \$(hostname)"
    tru64.PBS: dmpirun -n $NP bash -c "./memtest $MB ${DIGITALMPI_ENV_MAGIC}"
    
  ToDo: fault tolerance + MPI-2
   - MPI_COMM_SPAWN ?
   - output error rate (first errorcycle + errors/cycles + ...)
  
 */

int main(int argn, char *argv[]){
  long int rnd, i, j, *a=0, mb=1000, num, bad=0;
  char *ss="";
  if (argn>1) mb=atoi(argv[1]);
  num = mb*1024*(1024l/sizeof(long int));
  a = (long int *) malloc(mb*1024*1024l);
  if (argn>2) ss=argv[2];
  if (argn>3)
   printf("%s malloc %dMB long= %d bit  num=%d a=%012lx\n",
    ss, (int)mb, (int)sizeof(long int)*8, (int)num, a);
  if (!a) exit(1);
  a[num-1]=rand();
  for (j=0; j<16 && bad<10; j++){
    rnd=rand();
    for (i=0; i<num; i++) a[i]=rnd;
    for (i=0; i<num; i++) if (a[i]!=rnd) {
       printf("%s ERROR bad data at a[%08x]=%08x != %08x diff=%08x (j=%d)\n",
         ss, i,(unsigned long)a[i], (unsigned long)rnd,
               (unsigned long)(a[i]^rnd),j); 
       bad++;
    }
    for (i=0; i<num; i++) a[i]=~rnd;
    for (i=0; i<num; i++) if (a[i]!=~rnd) {
       printf("%s ERROR bad data at a[%08x]=%08x != %08x diff=%08x (j=%d)\n",
         ss, i,(unsigned long)a[i], (unsigned long)~rnd,
               (unsigned long)(a[i]^~rnd),j);
       bad++;
     }
  }  
  return bad;
}
